Index: /LMDZ5/branches/testing/libf/dyn3dmem/dynredem_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3dmem/dynredem_mod.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/dyn3dmem/dynredem_mod.F90	(revision 2408)
@@ -1,206 +1,276 @@
-!
-! $Id$
-!
 MODULE dynredem_mod
 
-CONTAINS
-
-  SUBROUTINE dynredem_write_u(ncid,id,var,ll)
   USE dimensions_mod
   USE parallel_lmdz
   USE mod_hallo
-  IMPLICIT NONE
-    INTEGER          :: ncid
-    CHARACTER(LEN=*) :: id
-    REAL             :: var(ijb_u:ije_u,ll)
-    REAL,ALLOCATABLE,SAVE  :: var_tmp(:,:)
-    REAL,ALLOCATABLE,SAVE  :: var_glo(:)
-    INTEGER          :: ll
-    INTEGER          :: count(4)
-    INTEGER          :: start(4)
-    INTEGER          :: l
-    INTEGER          :: nvarid
-    INTEGER          :: ierr
-    INCLUDE 'netcdf.inc'    
+  USE netcdf
+  PRIVATE
+  PUBLIC :: dynredem_write_u, dynredem_write_v, dynredem_read_u, err
+  PUBLIC :: cre_var, get_var1, put_var, fil, modname, msg
+  CHARACTER(LEN=256), SAVE :: fil, modname
+  INTEGER,            SAVE :: nvarid
+
+
+CONTAINS
+
+
+!===============================================================================
+!
+SUBROUTINE dynredem_write_u(ncid,id,var,ll)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  INTEGER,          INTENT(IN) :: ncid
+  CHARACTER(LEN=*), INTENT(IN) :: id
+  REAL,             INTENT(IN) :: var(ijb_u:ije_u,ll)
+  INTEGER,          INTENT(IN) :: ll
+!===============================================================================
+! Local variables:
+  REAL, ALLOCATABLE, SAVE :: var_tmp(:,:), var_glo(:)
+  INTEGER :: start(4), count(4), l, ierr
+!===============================================================================
+  start(:)=[1,1,1,1]; count(:)=[iip1,jjp1,1,1]
+
+!$OMP MASTER
+  IF(mpi_rank==0) CALL err(NF90_INQ_VARID(ncid,id,nvarid),"inq",id)
+!$OMP END MASTER
+
+!$OMP MASTER
+  ALLOCATE(var_tmp(ijb_u:ije_u,ll),var_glo(ip1jmp1))
+!$OMP END MASTER
+!$OMP BARRIER
+
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l=1,ll; var_tmp(:,l)=var(:,l); END DO
+  DO l=1,ll
+    CALL gather_field_u(var_tmp(:,l),var_glo,1)
+    IF(mpi_rank==0) THEN
+    !$OMP MASTER
+      start(3)=l
+      CALL err(NF90_PUT_VAR(ncid,nvarid,var_glo,start,count),"put",id)
+    !$OMP END MASTER
+    END IF
+  END DO
+!$OMP BARRIER
+!$OMP MASTER
+  DEALLOCATE(var_glo,var_tmp)
+!$OMP END MASTER
+!$OMP BARRIER
+  
+END SUBROUTINE dynredem_write_u
+!
+!===============================================================================
+
+
+!===============================================================================
+!
+SUBROUTINE dynredem_write_v(ncid,id,var,ll)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  INTEGER,          INTENT(IN) :: ncid
+  CHARACTER(LEN=*), INTENT(IN) :: id
+  REAL,             INTENT(IN) :: var(ijb_v:ije_v,ll)
+  INTEGER,          INTENT(IN) :: ll
+!===============================================================================
+! Local variables:
+  REAL, ALLOCATABLE, SAVE :: var_tmp(:,:), var_glo(:)
+  INTEGER :: start(4), count(4), l, ierr
+!===============================================================================
+  start(:)=[1,1,1,1]; count(:)=[iip1,jjm,1,1]
+
+!$OMP MASTER
+  IF(mpi_rank==0) CALL err(NF90_INQ_VARID(ncid,id,nvarid),"inq",id)
+!$OMP END MASTER
+
+!$OMP MASTER
+  ALLOCATE(var_tmp(ijb_v:ije_v,ll),var_glo(ip1jm))
+!$OMP END MASTER
+!$OMP BARRIER
+
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l=1,ll; var_tmp(:,l)=var(:,l); END DO
+  DO l=1,ll
+    CALL gather_field_v(var_tmp(:,l),var_glo,1)
+    IF(mpi_rank==0) THEN
+    !$OMP MASTER
+      start(3)=l
+      CALL err(NF90_PUT_VAR(ncid,nvarid,var_glo,start,count),"put",id)
+    !$OMP END MASTER
+    END IF
+  END DO
+!$OMP BARRIER
+!$OMP MASTER
+  DEALLOCATE(var_glo,var_tmp)
+!$OMP END MASTER
+!$OMP BARRIER
+  
+END SUBROUTINE dynredem_write_v
+!
+!===============================================================================
+
+
+!===============================================================================
+!
+SUBROUTINE dynredem_read_u(ncid,id,var,ll)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  INTEGER,          INTENT(IN)  :: ncid
+  CHARACTER(LEN=*), INTENT(IN)  :: id
+  REAL,             INTENT(OUT) :: var(ijb_u:ije_u,ll)
+  INTEGER,          INTENT(IN)  :: ll
+!===============================================================================
+! Local variables:
+  REAL, ALLOCATABLE, SAVE :: var_tmp(:,:), var_glo(:)
+  INTEGER :: start(4), count(4), l, ierr
+!===============================================================================
+  start(:)=[1,1,1,1]; count(:)=[iip1,jjp1,1,1]
+
+!$OMP MASTER
+  IF(mpi_rank==0) CALL err(NF90_INQ_VARID(ncid,id,nvarid),'inq',id)
+!$OMP END MASTER
+
+!$OMP MASTER
+  ALLOCATE(var_tmp(ijb_u:ije_u,ll),var_glo(ip1jmp1))
+!$OMP END MASTER
+!$OMP BARRIER
+
+  DO l=1,ll
+    IF(mpi_rank==0) THEN
+    !$OMP MASTER
+      start(3)=l
+      CALL err(NF90_GET_VAR(ncid,nvarid,var_glo,start,count),"get",id)
+    !$OMP END MASTER
+    END IF
+    CALL scatter_field_u(var_glo,var_tmp(:,l),1)
+  END DO
+
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l=1,ll; var(:,l)=var_tmp(:,l); END DO
     
-    count(:)=(/ iip1,jjp1,1,1 /)
-    start(:)=(/ 1,1,1,1 /)
-    
-!$OMP MASTER    
-   IF (mpi_rank==0) THEN
-     ierr = NF_INQ_VARID(ncid, id, nvarid)
-     IF (ierr .NE. NF_NOERR) THEN
-       PRINT*, "Variable "//id//" n est pas definie"
-       CALL abort
-     ENDIF
-   ENDIF
-!$OMP END MASTER
-
-!$OMP MASTER
-    ALLOCATE(var_tmp(ijb_u:ije_u,ll))
-    ALLOCATE(var_glo(ip1jmp1))
-!$OMP END MASTER
-!$OMP BARRIER
-
-!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
-    DO l=1,ll
-      var_tmp(:,l)=var(:,l)
-    ENDDO
-
-    DO l=1,ll
-      CALL gather_field_u(var_tmp(:,l),var_glo,1)
-       IF (mpi_rank==0) THEN
-   !$OMP MASTER
-        start(3)=l
+!$OMP BARRIER
+!$OMP MASTER
+  DEALLOCATE(var_glo,var_tmp)
+!$OMP END MASTER
+!$OMP BARRIER
+  
+END SUBROUTINE dynredem_read_u    
+!
+!===============================================================================
+
+
+!===============================================================================
+!
+SUBROUTINE cre_var(ncid,var,title,did,units)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  INTEGER,                    INTENT(IN) :: ncid
+  CHARACTER(LEN=*),           INTENT(IN) :: var, title
+  INTEGER,                    INTENT(IN) :: did(:)
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: units
+!===============================================================================
 #ifdef NC_DOUBLE
-        ierr = NF_PUT_VARA_DOUBLE (ncid,nvarid,start,count,var_glo)
+  CALL err(NF90_DEF_VAR(ncid,var,NF90_DOUBLE,did,nvarid),"inq",var)
 #else
-        ierr = NF_PUT_VARA_REAL (ncid,nvarid,start,count,var_glo)
+  CALL err(NF90_DEF_VAR(ncid,var,NF90_FLOAT ,did,nvarid),"inq",var)
 #endif
-   !$OMP END MASTER
-       ENDIF
-    ENDDO
-    
-  !$OMP BARRIER
-  !$OMP MASTER
-    DEALLOCATE(var_tmp)
-    DEALLOCATE(var_glo)
-  !$OMP END MASTER
-  !$OMP BARRIER
-  
-  END SUBROUTINE dynredem_write_u
-      
-  SUBROUTINE dynredem_write_v(ncid,id,var,ll)
-  USE dimensions_mod
-  USE parallel_lmdz
-  USE mod_hallo
-  IMPLICIT NONE
-    INTEGER          :: ncid
-    CHARACTER(LEN=*) :: id
-    REAL             :: var(ijb_v:ije_v,ll)
-    REAL,ALLOCATABLE,SAVE  :: var_tmp(:,:)
-    REAL,ALLOCATABLE,SAVE  :: var_glo(:)
-    INTEGER          :: ll
-    INTEGER          :: count(4)
-    INTEGER          :: start(4)
-    INTEGER          :: l
-    INTEGER          :: nvarid
-    INTEGER          :: ierr
-    INCLUDE 'netcdf.inc'    
-    
-    count(:)=(/ iip1,jjm,1,1 /)
-    start(:)=(/ 1,1,1,1 /)
-    
-!$OMP MASTER    
-   IF (mpi_rank==0) THEN
-     ierr = NF_INQ_VARID(ncid, id, nvarid)
-     IF (ierr .NE. NF_NOERR) THEN
-       PRINT*, "Variable "//id//" n est pas definie"
-       CALL abort
-     ENDIF
-   ENDIF
-!$OMP END MASTER
- 
-!$OMP MASTER
-    ALLOCATE(var_tmp(ijb_v:ije_v,ll))
-    ALLOCATE(var_glo(ip1jm))
-!$OMP END MASTER
-!$OMP BARRIER
-
-!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
-    DO l=1,ll
-      var_tmp(:,l)=var(:,l)
-    ENDDO
-
-    DO l=1,ll
-      CALL gather_field_v(var_tmp(:,l),var_glo,1)
-       IF (mpi_rank==0) THEN
-   !$OMP MASTER
-        start(3)=l
-#ifdef NC_DOUBLE
-        ierr = NF_PUT_VARA_DOUBLE (ncid,nvarid,start,count,var_glo)
-#else
-        ierr = NF_PUT_VARA_REAL (ncid,nvarid,start,count,var_glo)
-#endif
-   !$OMP END MASTER
-       ENDIF
-    ENDDO
-    
-  !$OMP BARRIER
-  !$OMP MASTER
-    DEALLOCATE(var_tmp)
-    DEALLOCATE(var_glo)
-  !$OMP END MASTER
-  !$OMP BARRIER
-  
-  END SUBROUTINE dynredem_write_v
-
-  SUBROUTINE dynredem_read_u(ncid,id,var,ll)
-  USE dimensions_mod
-  USE parallel_lmdz
-  USE mod_hallo
-  IMPLICIT NONE
-    INTEGER          :: ncid
-    CHARACTER(LEN=*) :: id
-    REAL             :: var(ijb_u:ije_u,ll)
-    REAL,ALLOCATABLE,SAVE  :: var_tmp(:,:)
-    REAL,ALLOCATABLE,SAVE  :: var_glo(:)
-    INTEGER          :: ll
-    INTEGER          :: count(4)
-    INTEGER          :: start(4)
-    INTEGER          :: l
-    INTEGER          :: nvarid
-    INTEGER          :: ierr
-    INCLUDE 'netcdf.inc'    
-    
-    count(:)=(/ iip1,jjp1,1,1 /)
-    start(:)=(/ 1,1,1,1 /)
-    
-!$OMP MASTER    
-   IF (mpi_rank==0) THEN
-     ierr = NF_INQ_VARID(ncid, id, nvarid)
-     IF (ierr .NE. NF_NOERR) THEN
-       PRINT*, "Variable "//id//" n est pas definie"
-       CALL abort
-     ENDIF
-   ENDIF
-!$OMP END MASTER
- 
-!$OMP MASTER
-    ALLOCATE(var_tmp(ijb_u:ije_u,ll))
-    ALLOCATE(var_glo(ip1jmp1))
-!$OMP END MASTER
-!$OMP BARRIER
-
-
-    DO l=1,ll
-       IF (mpi_rank==0) THEN
-   !$OMP MASTER
-        start(3)=l
-#ifdef NC_DOUBLE
-        ierr = NF_GET_VARA_DOUBLE (ncid,nvarid,start,count,var_glo)
-#else
-        ierr = NF_GET_VARA_REAL (ncid,nvarid,start,count,var_glo)
-#endif
-   !$OMP END MASTER
-       ENDIF
-       CALL scatter_field_u(var_glo,var_tmp(:,l),1)
-    ENDDO
-
-!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
-    DO l=1,ll
-      var(:,l)=var_tmp(:,l)
-    ENDDO
-    
-  !$OMP BARRIER
-  !$OMP MASTER
-    DEALLOCATE(var_tmp)
-    DEALLOCATE(var_glo)
-  !$OMP END MASTER
-  !$OMP BARRIER
-  
-  END SUBROUTINE dynredem_read_u    
-  
+  IF(title/="")      CALL err(NF90_PUT_ATT(ncid,nvarid,"title",title),var)
+  IF(PRESENT(units)) CALL err(NF90_PUT_ATT(ncid,nvarid,"units",units),var)
+
+END SUBROUTINE cre_var
+!
+!===============================================================================
+
+
+!===============================================================================
+!
+SUBROUTINE put_var(ncid,var,title,did,v,units)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  INTEGER,                    INTENT(IN) :: ncid
+  CHARACTER(LEN=*),           INTENT(IN) :: var, title
+  INTEGER,                    INTENT(IN) :: did(:)
+  REAL,                       INTENT(IN) :: v(:)
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: units
+!===============================================================================
+  INTEGER :: nd, k, nn(2)
+  IF(     PRESENT(units)) CALL cre_var(ncid,var,title,did,units)
+  IF(.NOT.PRESENT(units)) CALL cre_var(ncid,var,title,did)
+  CALL err(NF90_ENDDEF(ncid))
+  nd=SIZE(did)
+  DO k=1,nd; CALL err(NF90_INQUIRE_DIMENSION(ncid,did(k),len=nn(k))); END DO
+  IF(nd==1) CALL err(NF90_PUT_VAR(ncid,nvarid,RESHAPE(v,nn(1:1))),var)
+  IF(nd==2) CALL err(NF90_PUT_VAR(ncid,nvarid,RESHAPE(v,nn(1:2))),var)
+  CALL err(NF90_REDEF(ncid))
+END SUBROUTINE put_var
+!
+!===============================================================================
+
+
+!===============================================================================
+!
+FUNCTION msg(typ,nam)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  CHARACTER(LEN=256)                     :: msg    !--- STANDARDIZED MESSAGE
+  CHARACTER(LEN=*),           INTENT(IN) :: typ    !--- TYPE OF OPERATION
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: nam    !--- FIELD NAME
+!===============================================================================
+  SELECT CASE(typ)
+    CASE('open');  msg="Opening failed for <"//TRIM(fil)//">"
+    CASE('close'); msg="Closing failed for <"//TRIM(fil)//">"
+    CASE('get');   msg="Reading failed for <"//TRIM(nam)//">"
+    CASE('put');   msg="Writting failed for <"//TRIM(nam)//">"
+    CASE('inq');   msg="Missing field <"//TRIM(nam)//">"
+    CASE('fnd');   msg="Found field <"//TRIM(nam)//">"
+  END SELECT
+  msg=TRIM(msg)//" in file <"//TRIM(fil)//">"
+
+END FUNCTION msg
+!
+!===============================================================================
+
+
+!===============================================================================
+!
+SUBROUTINE err(ierr,typ,nam)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  INTEGER,                    INTENT(IN) :: ierr   !--- NetCDF ERROR CODE
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: typ    !--- TYPE OF OPERATION
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: nam    !--- FIELD NAME
+!===============================================================================
+  IF(ierr==NF90_NoERR) RETURN
+  IF(.NOT.PRESENT(typ)) THEN
+    CALL ABORT_gcm(modname,NF90_STRERROR(ierr),ierr)
+  ELSE
+    CALL ABORT_gcm(modname,msg(typ,nam),ierr)
+  END IF
+
+END SUBROUTINE err
+!
+!===============================================================================
+
 END MODULE dynredem_mod   
+
     
     
Index: /LMDZ5/branches/testing/libf/dyn3dmem/enercin_loc.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3dmem/enercin_loc.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3dmem/enercin_loc.F90	(revision 2408)
@@ -0,0 +1,84 @@
+SUBROUTINE enercin_loc ( vcov, ucov, vcont, ucont, ecin )
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van.
+!-------------------------------------------------------------------------------
+! Purpose: Compute kinetic energy at sigma levels.
+  USE parallel_lmdz
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom.h"
+!===============================================================================
+! Arguments:
+  REAL, INTENT(IN)  :: vcov    (ijb_v:ije_v,llm)
+  REAL, INTENT(IN)  :: ucov    (ijb_u:ije_u,llm)
+  REAL, INTENT(IN)  :: vcont   (ijb_v:ije_v,llm)
+  REAL, INTENT(IN)  :: ucont   (ijb_u:ije_u,llm)
+  REAL, INTENT(OUT) :: ecin    (ijb_u:ije_u,llm)
+!===============================================================================
+! Notes:
+!                 . V
+!                i,j-1
+!
+!      alpha4 .       . alpha1
+!
+!
+!        U .      . P     . U
+!       i-1,j    i,j      i,j
+!
+!      alpha3 .       . alpha2
+!
+!
+!                 . V
+!                i,j
+!
+! Kinetic energy at scalar point P(i,j) (excluding poles) is:
+!       Ecin = 0.5 * U(i-1,j)**2 *( alpha3 + alpha4 )  +
+!              0.5 * U(i  ,j)**2 *( alpha1 + alpha2 )  +
+!              0.5 * V(i,j-1)**2 *( alpha1 + alpha4 )  +
+!              0.5 * V(i,  j)**2 *( alpha2 + alpha3 )
+!===============================================================================
+! Local variables:
+  INTEGER :: l, ij, i, ijb, ije
+  REAL    :: ecinni(iim), ecinsi(iim), ecinpn, ecinps
+!===============================================================================
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l=1,llm
+
+    ijb=ij_begin
+    ije=ij_end+iip1
+
+    IF(pole_nord) ijb=ij_begin+iip1
+    IF(pole_sud)  ije=ij_end-iip1
+
+    DO ij = ijb,ije-1
+      ecin(ij+1,l)=0.5*(ucov(ij    ,l)*ucont(ij    ,l)*alpha3p4(ij +1)          &
+                      + ucov(ij+1  ,l)*ucont(ij+1  ,l)*alpha1p2(ij +1)          &
+                      + vcov(ij-iim,l)*vcont(ij-iim,l)*alpha1p4(ij +1)          &
+                      + vcov(ij+1  ,l)*vcont(ij+1  ,l)*alpha2p3(ij +1) )
+    END DO
+
+    !--- Correction: ecin(1,j,l)= ecin(iip1,j,l)
+    DO ij=ijb,ije,iip1; ecin(ij,l) = ecin(ij+iim,l); END DO
+
+    !--- North pole
+    IF(pole_nord) THEN
+      ecinni(:) = vcov(1:iim,l)*vcont(1:iim,l)*aire(1:iim)
+      ecinpn = 0.5*SUM(ecinni)/apoln
+      ecin(1:iip1,l)=ecinpn
+    END IF
+
+    !--- South pole
+    IF(pole_sud) THEN
+      DO i=1,iim
+        ecinsi(i) = vcov(i+ip1jmi1,l)*vcont(i+ip1jmi1,l)*aire(i+ip1jm)
+      END DO
+      ecinps = 0.5*SUM(ecinsi)/apols
+      ecin(1+ip1jm:ip1jmp1,l)=ecinps
+    END IF
+  END DO
+!$OMP END DO NOWAIT
+
+END SUBROUTINE enercin_loc
+
Index: /LMDZ5/branches/testing/libf/dyn3dmem/flumass_loc.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3dmem/flumass_loc.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3dmem/flumass_loc.F90	(revision 2408)
@@ -0,0 +1,91 @@
+SUBROUTINE flumass_loc(massebx,masseby, vcont, ucont, pbaru, pbarv )
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van , Fr. Hourdin.
+!-------------------------------------------------------------------------------
+! Purpose: Compute mass flux at s levels.
+  USE parallel_lmdz
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom.h"
+!===============================================================================
+! Arguments:
+  REAL, INTENT(IN)  :: massebx(ijb_u:ije_u,llm)
+  REAL, INTENT(IN)  :: masseby(ijb_v:ije_v,llm)
+  REAL, INTENT(IN)  :: vcont  (ijb_v:ije_v,llm)
+  REAL, INTENT(IN)  :: ucont  (ijb_u:ije_u,llm)
+  REAL, INTENT(OUT) :: pbaru  (ijb_u:ije_u,llm)
+  REAL, INTENT(OUT) :: pbarv  (ijb_v:ije_v,llm)
+!===============================================================================
+! Method used:   A 2 equations system is solved.
+!   * 1st one describes divergence computation at pole point nr. i (i=1 to im):
+!     (0.5*(pbaru(i)-pbaru(i-1))-pbarv(i))/aire(i) = - SUM(pbarv(n))/aire pole
+!   * 2nd one specifies that mean mass flux at pole is equal to 0:
+!     SUM(pbaru(n)*local_area(n))=0
+! This way, we determine additive constant common to pbary elements representing
+!   pbaru(0,j,l) in divergence computation equation for point i=1. (i=1 to im)
+!===============================================================================
+! Local variables:
+  REAL    :: sairen, saireun, ctn, ctn0, apbarun(iim)
+  REAL    :: saires, saireus, cts, cts0, apbarus(iim)
+  INTEGER :: l, i, ij, ijb, ije
+!===============================================================================
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)    
+  DO l=1,llm
+
+    ijb=ij_begin
+    ije=ij_end+iip1
+    IF(pole_nord) ijb=ij_begin+iip1
+    IF(pole_sud)  ije=ij_end-iip1
+    pbaru(ijb:ije,l)=massebx(ijb:ije,l)*ucont(ijb:ije,l)
+
+    ijb=ij_begin-iip1
+    ije=ij_end+iip1
+    IF(pole_nord) ijb=ij_begin
+    IF(pole_sud)  ije=ij_end-iip1
+    pbarv(ijb:ije,l)=masseby(ijb:ije,l)*vcont(ijb:ije,l)
+
+  END DO
+!$OMP END DO NOWAIT
+
+  !--- North pole
+  IF(pole_nord) THEN
+    sairen =SUM(aire (1:iim))
+    saireun=SUM(aireu(1:iim))
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)    
+    DO l=1,llm
+      ctn=SUM(pbarv(1:iim,l))/sairen
+      pbaru(1,l)= pbarv(1,l)-ctn*aire(1)
+      DO i=2,iim
+        pbaru(i,l)=pbaru(i-1,l)+pbarv(i,l)-ctn*aire(i)
+      END DO
+      apbarun(:)=aireu(1:iim)*pbaru(1:iim,l)
+      ctn0 = -SUM(apbarun)/saireun
+      pbaru(1:iim,l)=2.*(pbaru(1:iim,l)+ctn0)
+      pbaru(iip1,l)=pbaru(1,l)
+    END DO
+!$OMP END DO NOWAIT              
+  END IF
+
+  !--- South pole
+  IF(pole_sud) THEN
+    saires =SUM(aire (ip1jm+1:ip1jmp1-1))
+    saireus=SUM(aireu(ip1jm+1:ip1jmp1-1))
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)    
+    DO l=1,llm
+      cts=SUM(pbarv(1+ip1jmi1:ip1jm-1,l))/saires
+      pbaru(1+ip1jm,l)=-pbarv(1+ip1jmi1,l)+cts*aire(1+ip1jm)
+      DO i=2,iim
+        pbaru(i+ip1jm,l)=pbaru(i-1+ip1jm,l)-pbarv(i+ip1jmi1,l)+cts*aire(i+ip1jm)
+      END DO
+      apbarus(:)=aireu(1+ip1jm:ip1jmp1-1)*pbaru(1+ip1jm:ip1jmp1-1,l)
+      cts0 = -SUM(apbarus)/saireus
+      pbaru(1+ip1jm:ip1jmp1-1,l)=2.*(pbaru(1+ip1jm:ip1jmp1-1,l)+cts0)
+      pbaru(ip1jmp1,l)=pbaru(1+ip1jm,l)
+    END DO
+!$OMP END DO NOWAIT         
+  END IF
+
+END SUBROUTINE flumass_loc
+
Index: /LMDZ5/branches/testing/libf/dyn3dmem/gcm.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3dmem/gcm.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/dyn3dmem/gcm.F90	(revision 2408)
@@ -10,7 +10,7 @@
   USE parallel_lmdz
   USE infotrac
-#ifdef CPP_PHYS
-  USE mod_interface_dyn_phys, ONLY: init_interface_dyn_phys
-#endif
+!#ifdef CPP_PHYS
+!  USE mod_interface_dyn_phys, ONLY: init_interface_dyn_phys
+!#endif
   USE mod_hallo
   USE Bands
@@ -18,15 +18,6 @@
   USE control_mod
 
-#ifdef INCA
-  ! Only INCA needs these informations (from the Earth's physics)
-  USE indice_sol_mod
-  USE mod_phys_lmdz_omp_data, ONLY: klon_omp 
-#endif
-
 #ifdef CPP_PHYS
-  !      USE mod_grid_phy_lmdz
-  !      USE mod_phys_lmdz_para, ONLY : klon_mpi_para_nb
-  !      USE dimphy
-  !      USE comgeomphy
+  USE iniphysiq_mod, ONLY: iniphysiq
 #endif
   IMPLICIT NONE
@@ -76,8 +67,4 @@
   include "tracstoke.h"
 
-#ifdef INCA
-  ! Only INCA needs these informations (from the Earth's physics)
-  !include "indicesol.h"
-#endif
 
   REAL zdtvr
@@ -155,11 +142,11 @@
   call Read_Distrib
 
-#ifdef CPP_PHYS
-  CALL Init_Phys_lmdz(iim,jjp1,llm,mpi_size,distrib_phys)
+!#ifdef CPP_PHYS
+!  CALL Init_Phys_lmdz(iim,jjp1,llm,mpi_size,distrib_phys)
   !#endif
   !      CALL set_bands
   !#ifdef CPP_PHYS
-  CALL Init_interface_dyn_phys
-#endif
+!  CALL Init_interface_dyn_phys
+!#endif
   CALL barrier
 
@@ -200,17 +187,4 @@
 #endif
 
-  IF (type_trac == 'inca') THEN
-#ifdef INCA
-     call init_const_lmdz( &
-          nbtr,anneeref,dayref, &
-          iphysiq,day_step,nday,  &
-          nbsrf, is_oce,is_sic, &
-          is_ter,is_lic, calend)
-
-     call init_inca_para( &
-          iim,jjm+1,llm,klon_glo,mpi_size, &
-          distrib_phys,COMM_LMDZ)
-#endif
-  END IF
 
   !-----------------------------------------------------------------------
@@ -400,22 +374,12 @@
      ! Physics:
 #ifdef CPP_PHYS
-     CALL iniphysiq(iim,jjm,llm,daysec,day_ini,dtphys/nsplit_phys, &
-          rlatu,rlonv,aire,cu,cv,rad,g,r,cpp, &
+     CALL iniphysiq(iim,jjm,llm, &
+          distrib_phys(mpi_rank),comm_lmdz, &
+          daysec,day_ini,dtphys/nsplit_phys, &
+          rlatu,rlatv,rlonu,rlonv,aire,cu,cv,rad,g,r,cpp, &
           iflag_phys)
 #endif
   ENDIF ! of IF ((iflag_phys==1).or.(iflag_phys>=100))
 
-
-  !-----------------------------------------------------------------------
-  !   Initialisation des dimensions d'INCA :
-  !   --------------------------------------
-  IF (type_trac == 'inca') THEN
-     !$OMP PARALLEL
-#ifdef INCA
-     CALL init_inca_dim(klon_omp,llm,iim,jjm, &
-          rlonu,rlatu,rlonv,rlatv)
-#endif
-     !$OMP END PARALLEL
-  END IF
 
   !-----------------------------------------------------------------------
Index: /LMDZ5/branches/testing/libf/dyn3dmem/leapfrog_loc.F
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3dmem/leapfrog_loc.F	(revision 2407)
+++ /LMDZ5/branches/testing/libf/dyn3dmem/leapfrog_loc.F	(revision 2408)
@@ -308,9 +308,12 @@
 
    1  CONTINUE ! Matsuno Forward step begins here
-      !write(*,*) 'leapfrog 298: itau=',itau
+
+c   date: (NB: date remains unchanged for Backward step)
+c   -----
+
       jD_cur = jD_ref + day_ini - day_ref +                             &
-     &          itau/day_step
+     &          (itau+1)/day_step
       jH_cur = jH_ref + start_time +                                    &
-     &         mod(itau,day_step)/float(day_step) 
+     &         mod(itau+1,day_step)/float(day_step) 
       if (jH_cur > 1.0 ) then
         jD_cur = jD_cur +1.
@@ -421,7 +424,17 @@
 c-----------------------------------------------------------------------
 
-c   date:
+c   date: (NB: only leapfrog step requires recomputing date)
 c   -----
 
+      IF (leapf) THEN
+        jD_cur = jD_ref + day_ini - day_ref +
+     &          (itau+1)/day_step
+        jH_cur = jH_ref + start_time +
+     &         mod(itau+1,day_step)/float(day_step) 
+        if (jH_cur > 1.0 ) then
+          jD_cur = jD_cur +1.
+          jH_cur = jH_cur -1.
+        endif
+      ENDIF
 
 c   gestion des appels de la physique et des dissipations:
Index: /LMDZ5/branches/testing/libf/dyn3dmem/massbar_loc.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3dmem/massbar_loc.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3dmem/massbar_loc.F90	(revision 2408)
@@ -0,0 +1,76 @@
+SUBROUTINE massbar_loc(masse,massebx,masseby)
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van , Fr. Hourdin.
+!-------------------------------------------------------------------------------
+! Purpose: Compute air mass mean along X and Y in each cell.
+! See iniconst for more details.
+  USE parallel_lmdz
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom.h"
+!===============================================================================
+! Arguments:
+  REAL, INTENT(IN)  :: masse  (ijb_u:ije_u,llm)
+  REAL, INTENT(OUT) :: massebx(ijb_u:ije_u,llm)
+  REAL, INTENT(OUT) :: masseby(ijb_v:ije_v,llm)
+!-------------------------------------------------------------------------------
+! Method used. Each scalar point is associated to 4 area coefficients:
+!    * alpha1(i,j) at point ( i+1/4,j-1/4 )
+!    * alpha2(i,j) at point ( i+1/4,j+1/4 )
+!    * alpha3(i,j) at point ( i-1/4,j+1/4 )
+!    * alpha4(i,j) at point ( i-1/4,j-1/4 )
+! where alpha1(i,j) = aire(i+1/4,j-1/4)/ aire(i,j)
+!
+!   alpha4 .         . alpha1    . alpha4
+!    (i,j)             (i,j)       (i+1,j)
+!
+!             P .        U .          . P
+!           (i,j)       (i,j)         (i+1,j)
+!
+!   alpha3 .         . alpha2    .alpha3 
+!    (i,j)              (i,j)     (i+1,j)
+!
+!             V .        Z .          . V
+!           (i,j)
+!
+!   alpha4 .         . alpha1    .alpha4
+!   (i,j+1)            (i,j+1)   (i+1,j+1) 
+!
+!             P .        U .          . P
+!          (i,j+1)                    (i+1,j+1)
+!
+!
+!    massebx(i,j) = masse(i  ,j) * ( alpha1(i  ,j) + alpha2(i,j))   +
+!                   masse(i+1,j) * ( alpha3(i+1,j) + alpha4(i+1,j) )
+!     localized at point  ... U (i,j) ...
+!
+!    masseby(i,j) = masse(i,j  ) * ( alpha2(i,j  ) + alpha3(i,j  )  +
+!                   masse(i,j+1) * ( alpha1(i,j+1) + alpha4(i,j+1)  
+!     localized at point  ... V (i,j) ...
+!===============================================================================
+! Local variables:
+  INTEGER :: ij, l, ijb, ije
+!===============================================================================
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)  
+  DO l=1,llm
+    ijb=ij_begin
+    ije=ij_end+iip1
+    IF(pole_sud) ije=ije-iip1
+    DO ij=ijb,ije-1
+      massebx(ij,l)=masse(ij,l)*alpha1p2(ij)+masse(ij+1   ,l)*alpha3p4(ij+1)
+    END DO
+    DO ij=ijb+iim,ije+iim,iip1; massebx(ij,l)=massebx(ij-iim,l); END DO
+    ijb=ij_begin-iip1
+    ije=ij_end+iip1
+    IF(pole_nord) ijb=ij_begin
+    IF(pole_sud) ije=ij_end-iip1
+    DO ij=ijb,ije
+      masseby(ij,l)=masse(ij,l)*alpha2p3(ij)+masse(ij+iip1,l)*alpha1p4(ij+iip1)
+    END DO
+  END DO
+!$OMP END DO NOWAIT
+
+END SUBROUTINE massbar_loc
+
Index: /LMDZ5/branches/testing/libf/dyn3dmem/massbarxy_loc.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3dmem/massbarxy_loc.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3dmem/massbarxy_loc.F90	(revision 2408)
@@ -0,0 +1,39 @@
+SUBROUTINE massbarxy_loc(masse,massebxy)
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van , Fr. Hourdin.
+!-------------------------------------------------------------------------------
+! Purpose: Compute air mass mean along X and Y in each cell.
+! See iniconst for more details.
+  USE parallel_lmdz
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comconst.h"
+  include "comgeom.h"
+!===============================================================================
+! Arguments:
+  REAL, INTENT(IN)  :: masse   (ijb_u:ije_u,llm)
+  REAL, INTENT(OUT) :: massebxy(ijb_v:ije_v,llm)
+!===============================================================================
+! Local variables:
+  INTEGER :: ij, l, ijb, ije
+!===============================================================================
+  ijb=ij_begin-iip1
+  ije=ij_end
+  IF(pole_nord) ijb=ijb+iip1
+  IF(pole_sud)  ije=ije-iip1
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)    
+  DO l=1,llm
+    DO ij=ijb,ije-1
+      massebxy(ij,l)=masse(ij     ,l)*alpha2(ij     ) + &
+     +               masse(ij+1   ,l)*alpha3(ij+1   ) + &
+     +               masse(ij+iip1,l)*alpha1(ij+iip1) + &
+     +               masse(ij+iip2,l)*alpha4(ij+iip2)
+    END DO
+    DO ij=ijb+iip1-1,ije+iip1-1,iip1; massebxy(ij,l)=massebxy(ij-iim,l); END DO
+  END DO
+!$OMP END DO NOWAIT
+
+END SUBROUTINE massbarxy_loc
+
